//+------------------------------------------------------------------+
//|                                                 chart_MACD_4.mq4 |
//|                      Copyright  2008, MetaQuotes Software Corp. |
//|                                        forex_@i.ua        KONDOR |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_separate_window
#property indicator_buffers 8

#property indicator_color1 Gray
#property indicator_color2 Gray
#property indicator_color3 Gray
#property indicator_color4 CLR_NONE
#property indicator_color5 CLR_NONE
#property indicator_color6 CLR_NONE
#property indicator_color7 CLR_NONE
#property indicator_color8 CLR_NONE

extern int EUR= 1;  //  ()   () () 
extern int GBP= 1;  // 0 - 
extern int AUD= 0;
extern int NZD= 0;
extern int USD= 1;
extern int CAD= 0;
extern int CHF= 0;
extern int JPY= 0;

extern int per1=25,per2=50,sign=3; //  
extern int History=200;           //      

int type=MODE_MAIN;

double z0[],z1[],z2[],z3[],z4[],z5[],z6[],z7[];

int ind[8];
int n[];
double z[];
string simb[];
int sum=0;

string Val[8]={"EUR","GBP","AUD","NZD","USD","CAD","CHF","JPY"};
color  Valcol[8]={Red,Violet,Yellow,LightSeaGreen,Green,Aqua,Orange,FireBrick};

string    short_name;
string text;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators

   ind[0]=EUR;
   ind[1]=GBP;
   ind[2]=AUD;
   ind[3]=NZD;
   ind[4]=USD;
   ind[5]=CAD;
   ind[6]=CHF;
   ind[7]=JPY;


   sum=0;
   for(int a=0; a<8; a++)
     {
      if(ind[a]!=0)
        { sum++; ArrayResize(n,sum);  n[sum-1]=a; }
     }

   ArrayResize(z,sum);
   ArrayResize(simb,sum);
   ArraySort(n,WHOLE_ARRAY,0,MODE_ASCEND); //    

   for(a=0; a<sum; a++)
     {

      if(a!=sum-1) simb[a]=Val[n[a]]+Val[n[a+1]]; else
      if(a==sum-1)simb[a]=Val[n[0]]+Val[n[sum-1]];

     }

//IndicatorBuffers(sum);
   IndicatorBuffers(8);

   SetIndexBuffer(0,z0);
   SetIndexBuffer(1,z1);
   SetIndexBuffer(2,z2);
   SetIndexBuffer(3,z3);
   SetIndexBuffer(4,z4);
   SetIndexBuffer(5,z5);
   SetIndexBuffer(6,z6);
   SetIndexBuffer(7,z7);

   text="";
   for(a=0;a<sum;a++)
     {
      SetIndexStyle(a,DRAW_LINE,EMPTY,EMPTY,col(a));
      SetIndexLabel(a,simb[a]);

      if(a==sum-1) text=simb[a];
      text=StringConcatenate( text, "     ");
     }

   IndicatorDigits(2);

   short_name=text;
   IndicatorShortName(short_name);

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {

   int counted_bars=IndicatorCounted();
//---- last counted bar will be recounted
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   int limit=Bars-counted_bars;
   if(counted_bars==0) limit--;

   if(limit>History-1) limit=History-1;
   ArrayResize(z,ArraySize(z0));
//-------------------------------------------------------------------------------------------
   int xtot=20;   int y=5;
   for(int  i=0;i<History;i++)
     {

      for(int a=0;a<sum;a++)
        {

         z[a]= delta(simb[a], i);
         if(a==sum-1)z[a]*=-1;

        }

      if(ArraySize(z)>0) z0[i]= z[0];
      if(ArraySize(z)>1) z1[i]= z[1];
      if(ArraySize(z)>2) z2[i]= z[2];
      if(ArraySize(z)>3) z3[i]= z[3];
      if(ArraySize(z)>4) z4[i]= z[4];
      if(ArraySize(z)>5) z5[i]= z[5];
      if(ArraySize(z)>6) z6[i]= z[6];
      if(ArraySize(z)>7) z7[i]= z[7];
     }

   double cls=1;
   for(a=0; a<sum; a++)
     {

        { ObjectDelete(simb[a]+"1"); Create_Tic( simb[a]+"1",simb[a]                         ,xtot+50, y+a*15, col(a)); }
        { ObjectDelete(simb[a]+"2"); Create_Tic( simb[a]+"2",DoubleToStr(delta(simb[a], 0),2),xtot,    y+a*15, col(a)); }

      double c=iClose(simb[a],0,0);
      if(a==sum-1) c=1/c;
      cls*=c;
     }

   cls*=Close[0];

   Create_Tic("chart_MACD_4",DoubleToStr(cls,Digits+1),500,40,Black);

//----
   return(0);
  }
//+------------------------------------------------------------------+

int deinit()
  {
//----

   for(int a=0;a<sum;a++)
     {
      SetIndexStyle(a,DRAW_LINE,EMPTY,EMPTY,CLR_NONE);
      SetIndexLabel(a,simb[a]);
      ObjectDelete(simb[a]+"1");
      ObjectDelete(simb[a]+"2");
     }

//----
   return(0);
  }
//----------------------------------------------------------------  

double delta(string simb,int i)
  {

   return((
          iMACD(simb,0,per1,per2,sign,PRICE_CLOSE,type,i)
          )/iClose(simb,0,i)*10000);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
color  col(int d)
  {  // -     

   if(d!=sum-1) return(Valcol[d]);
   else         return(Black);

  }
//--------------------------------------------------------

int Create_Tic(string name,string text,int x,int y,color  c)
  {
   ObjectDelete(name);
   ObjectCreate(name,OBJ_LABEL,WindowFind(short_name),0,0);
   ObjectSetText(name,text,8,"Tahoma Narrow",c);
   ObjectSet(name,OBJPROP_CORNER,1);
   ObjectSet(name,OBJPROP_XDISTANCE,x);
   ObjectSet(name,OBJPROP_YDISTANCE,y);
   return;
  }
//+------------------------------------------------------------------+
